alter table BN_USER_ROLE drop foreign key FKBCD30837E42731DA;
alter table BN_USER_ROLE drop foreign key FKBCD30837EA9FC244;

alter table BN_ACT_DEF modify DESCRIPTION_ longtext;
alter table BN_ACT_DEF modify DYN_LABEL_ longtext;
alter table BN_ACT_DEF modify DYN_DESCRIPTION_ longtext;
alter table BN_ACT_DEF add DYN_EXECUTION_SUMMARY_ longtext;
alter table BN_ACT_DEF modify TIMER_COND longtext;
alter table BN_ACT_DEF modify LOOP_CONDITION_ longtext;
alter table BN_ACT_DEF modify LOOP_MAXIMUM_ longtext;
alter table BN_ACT_DEF add CATCH_ERROR_ bit;
update BN_ACT_DEF set CATCH_ERROR_ = b'0';

alter table BN_ACT_INST modify DESCR longtext;
alter table BN_ACT_INST modify DYN_DESCR longtext;
alter table BN_ACT_INST modify DYN_LABEL longtext;
alter table BN_ACT_INST add DYN_EXECUTION_SUMMARY longtext;
alter table BN_ACT_INST add LOOP_ID_ varchar(255);

alter table BN_ATTACH_DEF modify FILE_PATH_ longtext;

alter table BN_ATTS_INST drop column ATT_INST_FILEPATH_;

rename table BN_WEB_LABEL to BN_CATEGORY;
alter table BN_CATEGORY add CATEGORY_TYPE_ varchar(255) default 'WEB_LABEL' not null;
alter table BN_CATEGORY add CATEGORY_UUID_ varchar(255);
alter table BN_CATEGORY add unique(CATEGORY_UUID_);

alter table BN_COMMENTS modify MESSAGE_ longtext;

alter table BN_CON_DEF add ERROR_CODE_ varchar(255);

alter table BN_DATAF_DEF modify ENUM_VALUES_ longtext;
alter table BN_DATAF_DEF modify SCRIPT_VALUE_ longtext;

alter table BN_ENTITY_RULE change column ENTITY_DBID_ ENTITY_ID_ varchar(255);

create table BN_EVENTS (
  DBID_ bigint not null auto_increment,
  CLASS_ varchar(255) not null,
  DESCRIPTION_ longtext,
  NAME_ varchar(255),
  LABEL_ varchar(255),
  PROCESS_UUID_ varchar(255),
  ACT_UUID_ varchar(255),
  TRANSITION_ bigint,
  CONDITION_ longtext,
  EXPRESSION_ varchar(255),
  ERROR_CODE_ varchar(255),
  SIGNAL_CODE_ varchar(255),
  EVT_DBID_ bigint,
  EVT_NAME_ varchar(255),
  primary key (DBID_)
);

create table BN_GROUP (
  DBID_ bigint not null auto_increment,
  GROUP_UUID_ varchar(255) unique,
  GROUP_NAME_ varchar(255),
  GROUP_LABEL_ varchar(255),
  GROUP_DESCRIPTION_ longtext,
  PARENT_GROUP_ bigint,
  primary key (DBID_)
);

create table BN_GROUP_RULE (
  RULE_DBID_ bigint not null,
  GROUP_UUID_ varchar(255)
);

create table BN_INCOMP_EVENTS (
  INCOMING_ID bigint not null,
  OUTGOING_ID bigint
);

alter table BN_IEI_ modify EXPR longtext;
alter table BN_IEI_ modify EXCEPTION_ longtext;

create table BN_INST_ACTUSERS (
  INSTANCE_DBID_ bigint not null,
  USER_ varchar(255),
  INDEX_ integer not null,
  primary key (INSTANCE_DBID_, INDEX_)
);

create table BN_MEMBERSHIP (
  DBID_ bigint not null auto_increment,
  MEMBERSHIP_UUID_ varchar(255) unique,
  MEMBERSHIP_ROLE_ bigint not null,
  MEMBERSHIP_GROUP_ bigint not null,
  primary key (DBID_),
  unique (MEMBERSHIP_ROLE_, MEMBERSHIP_GROUP_)
);

create table BN_MEMBERSHIP_RULE (
  RULE_DBID_ bigint not null,
  MEMBERSHIP_UUID_ varchar(255)
);

alter table BN_METADATA modify VALUE_ longtext;

create table BN_PROC_CAT (
  PROC_ID bigint not null,
  CAT_ varchar(255)
);

alter table BN_PROC_INST add PARENT_ACT_INST_UUID_ varchar(255);
alter table BN_PROC_INST add ARCHIVED bit;
update BN_PROC_INST set ARCHIVED=b'0';

create table BN_PROFILE_METADATA (
  DBID_ bigint not null auto_increment,
  PROFILE_METADATA_UUID_ varchar(255) unique,
  PROFILE_METADATA_NAME_ varchar(255) unique,
  PROFILE_METADATA_LABEL_ varchar(255),
  primary key (DBID_)
);

alter table BN_ROLE modify ROLE_DESCRIPTION_ longtext;

create table BN_ROLE_RULE (
  RULE_DBID_ bigint not null,
  ROLE_UUID_ varchar(255)
);

alter table BN_RULE add RULE_UUID_ varchar(255);
alter table BN_RULE add unique (RULE_UUID_);
alter table BN_RULE modify RULE_DESCRIPTION_ longtext;
update BN_RULE set RULE_TYPE_ = 'PROCESS_RULE' where RULE_TYPE_ = 'P_START';
update BN_RULE set RULE_TYPE_ = 'PROCESS_RULE' where RULE_TYPE_ = 'P_READ';

create table BN_RULETYPE_POLICY (
  DBID_ bigint not null auto_increment,
  RULE_TYPE_VALUE_ varchar(255),
  POLICY_VALUE_ varchar(255),
  primary key (DBID_)
);

alter table BN_TRANS_DEF add FROM_BOUNDARY_EVT_ varchar(255);
alter table BN_TRANS_DEF modify CONDITION_ longtext;

alter table BN_USER add USER_TITLE_ varchar(255);
alter table BN_USER add USER_JOBTITLE_ varchar(255);
alter table BN_USER add USER_MANAGER_ varchar(255);
alter table BN_USER add USER_DELEGEE_ varchar(255);
alter table BN_USER change USER_EMAIL_ USER_PRO_EMAIL_ varchar(255);
alter table BN_USER add USER_PRO_PHONE_ varchar(255);
alter table BN_USER add USER_PRO_MOBILE_ varchar(255);
alter table BN_USER add USER_PRO_FAX_ varchar(255);
alter table BN_USER add USER_PRO_BUILDING_ varchar(255);
alter table BN_USER add USER_PRO_ROOM_ varchar(255);
alter table BN_USER add USER_PRO_ADDRESS_ varchar(255);
alter table BN_USER add USER_PRO_ZIPCODE_ varchar(255);
alter table BN_USER add USER_PRO_CITY_ varchar(255);
alter table BN_USER add USER_PRO_STATE_ varchar(255);
alter table BN_USER add USER_PRO_COUNTRY_ varchar(255);
alter table BN_USER add USER_PRO_WEBSITE_ varchar(255);
alter table BN_USER add USER_PERSO_EMAIL_ varchar(255);
alter table BN_USER add USER_PERSO_PHONE_ varchar(255);
alter table BN_USER add USER_PERSO_MOBILE_ varchar(255);
alter table BN_USER add USER_PERSO_FAX_ varchar(255);
alter table BN_USER add USER_PERSO_BUILDING_ varchar(255);
alter table BN_USER add USER_PERSO_ROOM_ varchar(255);
alter table BN_USER add USER_PERSO_ADDRESS_ varchar(255);
alter table BN_USER add USER_PERSO_ZIPCODE_ varchar(255);
alter table BN_USER add USER_PERSO_CITY_ varchar(255);
alter table BN_USER add USER_PERSO_STATE_ varchar(255);
alter table BN_USER add USER_PERSO_COUNTRY_ varchar(255);
alter table BN_USER add USER_PERSO_WEBSITE_ varchar(255);

create table BN_USER_MEMBERSHIP (
    USER_DBID_ bigint not null,
    MEMBERSHIP_DBID_ bigint not null,
    primary key (USER_DBID_, MEMBERSHIP_DBID_)
);

create table BN_USER_PROFILE_METADATA (
    USER_DBID_ bigint not null,
    USER_METADATA_VALUE_ varchar(255),
    PROFILE_METADATA_DBID_ bigint not null,
    primary key (USER_DBID_, PROFILE_METADATA_DBID_)
);

drop table BN_USER_ROLE;

create table BN_USER_RULE (
  RULE_DBID_ bigint not null,
  USER_UUID_ varchar(255)
);

alter table BN_VAR modify TEXT_VALUE_ longtext;

drop table BN_WEB_USER;

alter table BN_EVENTS add index FKFC4B1C6CE4527CDB (EVT_DBID_), 
  add constraint FKFC4B1C6CE4527CDB foreign key (EVT_DBID_) references BN_ACT_DEF (DBID_);
alter table BN_EVENTS add index FKFC4B1C6C9F5E2C47 (TRANSITION_),
  add constraint FKFC4B1C6C9F5E2C47 foreign key (TRANSITION_) references BN_TRANS_DEF (DBID_);

create index IDX_GROUP_PARENT on BN_GROUP (PARENT_GROUP_);
create index IDX_GROUP_NAME on BN_GROUP (GROUP_NAME_);
create index IDX_GROUP_UUID on BN_GROUP (GROUP_UUID_);
alter table BN_GROUP add index FK8C5F00AC3308C74D (PARENT_GROUP_), 
  add constraint FK8C5F00AC3308C74D foreign key (PARENT_GROUP_) references BN_GROUP (DBID_);

alter table BN_GROUP_RULE add index FK81E3D2AF5D39E3A7 (RULE_DBID_), 
  add constraint FK81E3D2AF5D39E3A7 foreign key (RULE_DBID_) references BN_RULE (DBID_);

create index IDX_INCOMING_INCOMP_ on BN_INCOMP_EVENTS (INCOMING_ID);
alter table BN_INCOMP_EVENTS add index FK_INCOMING_INCOMP (INCOMING_ID),
  add constraint FK_INCOMING_INCOMP foreign key (INCOMING_ID) references BN_IEI_ (DBID_);

create index IDX_INST_ACTUSERS on BN_INST_ACTUSERS (INSTANCE_DBID_);
alter table BN_INST_ACTUSERS add index FK_INST_ACTUSERS (INSTANCE_DBID_), 
  add constraint FK_INST_ACTUSERS foreign key (INSTANCE_DBID_) references BN_PROC_INST (DBID_);

create index IDX_MEMBERSHIP_UUID on BN_MEMBERSHIP (MEMBERSHIP_UUID_);
alter table BN_MEMBERSHIP add index FKE3CDD9A9734D1EA1 (MEMBERSHIP_GROUP_), 
  add constraint FKE3CDD9A9734D1EA1 foreign key (MEMBERSHIP_GROUP_) references BN_GROUP (DBID_);
alter table BN_MEMBERSHIP add index FKE3CDD9A928CF6E7D (MEMBERSHIP_ROLE_), 
  add constraint FKE3CDD9A928CF6E7D foreign key (MEMBERSHIP_ROLE_) references BN_ROLE (DBID_);

alter table BN_MEMBERSHIP_RULE add index FKE5B60FD25D39E3A7 (RULE_DBID_), 
  add constraint FKE5B60FD25D39E3A7 foreign key (RULE_DBID_) references BN_RULE (DBID_);

create index IDX_PROC_CAT on BN_PROC_CAT (PROC_ID);

alter table BN_PROC_CAT add index FK_PROC_CAT (PROC_ID), 
  add constraint FK_PROC_CAT foreign key (PROC_ID) references BN_PROC_DEF (DBID_);

create index IDX_PROFILE_METADATA_UUID on BN_PROFILE_METADATA (PROFILE_METADATA_UUID_);
create index IDX_PROFILE_METADATA_NAME on BN_PROFILE_METADATA (PROFILE_METADATA_NAME_);
  
alter table BN_ROLE_RULE add index FKBC9DBCF25D39E3A7 (RULE_DBID_), 
  add constraint FKBC9DBCF25D39E3A7 foreign key (RULE_DBID_) references BN_RULE (DBID_);

create index IDX_RULE_UUID on BN_RULE (RULE_UUID_);

alter table BN_USER_MEMBERSHIP add index FKD55F6ED7A76CD75A (MEMBERSHIP_DBID_), 
  add constraint FKD55F6ED7A76CD75A foreign key (MEMBERSHIP_DBID_) references BN_MEMBERSHIP (DBID_);
alter table BN_USER_MEMBERSHIP add index FKD55F6ED7EA9FC244 (USER_DBID_), 
  add constraint FKD55F6ED7EA9FC244 foreign key (USER_DBID_) references BN_USER (DBID_);

alter table BN_USER_PROFILE_METADATA add index FKA3C9A766FE1E43BD (PROFILE_METADATA_DBID_), 
  add constraint FKA3C9A766FE1E43BD foreign key (PROFILE_METADATA_DBID_) references BN_PROFILE_METADATA (DBID_);
alter table BN_USER_PROFILE_METADATA add index FKA3C9A766EA9FC244 (USER_DBID_), 
  add constraint FKA3C9A766EA9FC244 foreign key (USER_DBID_) references BN_USER (DBID_);

alter table BN_USER_RULE add index FKBCD31EBD5D39E3A7 (RULE_DBID_), 
  add constraint FKBCD31EBD5D39E3A7 foreign key (RULE_DBID_) references BN_RULE (DBID_);
