alter table BN_ACT_DEF add DYN_LABEL_ text;
alter table BN_ACT_DEF add DYN_DESCRIPTION_ text;
alter table BN_ACT_DEF add SUBFLOW_VERSION_ varchar(255);
alter table BN_ACT_DEF add INSTANTIATOR_ int8;
alter table BN_ACT_DEF add JOIN_CHECKER_ int8;
alter table BN_ACT_DEF add LOOP_ bool;
update BN_ACT_DEF set LOOP_=false;
alter table BN_ACT_DEF add BEFORE_EXECUTION_ bool;
update BN_ACT_DEF set BEFORE_EXECUTION_=false;
alter table BN_ACT_DEF add LOOP_CONDITION_ text;
alter table BN_ACT_DEF add LOOP_MAXIMUM_ text;

alter table BN_ACT_INST add DYN_LABEL text;
alter table BN_ACT_INST add DYN_DESCR text;

alter table BN_ATTACH_DEF alter FILE_PATH_ type text;

alter table BN_ATTS_INST alter ATT_INST_FILEPATH_ type text;

create table BN_ATTS_METADATA (
  ATT_DBID_ int8 not null,
  VALUE_ varchar(255),
  KEY_ varchar(255) not null,
  primary key (ATT_DBID_, KEY_)
);

alter table BN_COMMENTS add PROCESS_UUID_ varchar(255);

alter table BN_IEI_ add PERMANENT_ bool;
update BN_IEI_ set PERMANENT_=false;
alter table BN_IEI_ add CONSUMED bool;
update BN_IEI_ set CONSUMED=false;

alter table BN_METADATA add unique (KEY_);

alter table BN_OEI_ add CONSUMED bool;
update BN_OEI_ set CONSUMED=false;

alter table BN_PROC_INST add XP_READ_ int8;
update BN_PROC_INST set XP_READ_=0;

alter table BN_PVM_EXEC add ACT_INST_NB_ int4;
update BN_PVM_EXEC set ACT_INST_NB_=0;

alter table BN_ROLE add ROLE_UUID_ varchar(255);

alter table BN_TRANS_DEF add DEFAULT_ bool;
update BN_TRANS_DEF set DEFAULT_=false;

alter table BN_USER add USER_UUID_ varchar(255);

alter table BN_WEB_CASE add LAST_UPDATE int8;
update BN_WEB_CASE set LAST_UPDATE=0;
alter table BN_WEB_CASE add LABEL_ varchar(255);
update BN_WEB_CASE set LABEL_='';

create table BN_WEB_TOKEN (
  DBID_ int8 not null,
  TOKEN varchar(255),
  EXPIRATION_DATE int8,
  IDENTITY_KEY varchar(255),
  primary key (DBID_)
);

alter table BN_ACT_DEF 
  add constraint FK99EE4DA5D6989A77 foreign key (INSTANTIATOR_) references BN_CON_DEF;

alter table BN_ACT_DEF 
  add constraint FK99EE4DA52169A115 foreign key (JOIN_CHECKER_) references BN_CON_DEF;

alter table BN_ATTS_METADATA 
  add constraint FK976540293C0CE5CF foreign key (ATT_DBID_) references BN_ATTS_INST;

alter table BN_METADATA drop constraint FK_ATT_METADATA_BR;
drop index IDX_ATT_METADATA_BR;
alter table BN_METADATA drop column ATT_ID_;

create index IDX_ROLE_UUID on BN_ROLE (ROLE_UUID_);

create index IDX_USER_UUID on BN_USER (USER_UUID_);

create index IDX_CASE_UPD on BN_WEB_CASE (LAST_UPDATE);
create index IDX_LABEL on BN_WEB_CASE (LABEL_);
create index IDX_CASE_OWN on BN_WEB_CASE (OWNER);
create index IDX_CASE_LAB on BN_WEB_CASE (NAME);