alter table BN_USER_ROLE drop constraint FKBCD30837E42731DA;
alter table BN_USER_ROLE drop constraint FKBCD30837EA9FC244;

alter table BN_ACT_DEF alter DESCRIPTION_ type text;
alter table BN_ACT_DEF add DYN_EXECUTION_SUMMARY_ text;
alter table BN_ACT_DEF alter TIMER_COND type text;
alter table BN_ACT_DEF add CATCH_ERROR_ bool default false;

alter table BN_ACT_INST alter DESCR type text;
alter table BN_ACT_INST add DYN_EXECUTION_SUMMARY text;
alter table BN_ACT_INST add LOOP_ID_ varchar(255);

alter table BN_ATTS_INST drop column ATT_INST_FILEPATH_;

alter table BN_WEB_LABEL RENAME to BN_CATEGORY;
alter table BN_CATEGORY add CATEGORY_TYPE_ varchar(255) default 'WEB_LABEL' not null;
alter table BN_CATEGORY add CATEGORY_UUID_ varchar(255);
alter table BN_CATEGORY add unique(CATEGORY_UUID_);

alter table BN_CON_DEF add ERROR_CODE_ varchar(255);

alter table BN_DATAF_DEF alter ENUM_VALUES_ type text;
alter table BN_DATAF_DEF alter SCRIPT_VALUE_ type text;

alter table BN_ENTITY_RULE rename ENTITY_DBID_ to ENTITY_ID_;

create table BN_EVENTS (
  DBID_ int8 not null,
  CLASS_ varchar(255) not null,
  DESCRIPTION_ text,
  NAME_ varchar(255),
  LABEL_ varchar(255),
  PROCESS_UUID_ varchar(255),
  ACT_UUID_ varchar(255),
  TRANSITION_ int8,
  CONDITION_ text,
  EXPRESSION_ varchar(255),
  ERROR_CODE_ varchar(255),
  SIGNAL_CODE_ varchar(255),
  EVT_DBID_ int8,
  EVT_NAME_ varchar(255),
  primary key (DBID_)
);
    
create table BN_GROUP (
  DBID_ int8 not null,
  GROUP_UUID_ varchar(255) unique,
  GROUP_NAME_ varchar(255),
  GROUP_LABEL_ varchar(255),
  GROUP_DESCRIPTION_ text,
  PARENT_GROUP_ int8,
  primary key (DBID_)
);  
    
create table BN_GROUP_RULE (
  RULE_DBID_ int8 not null,
  GROUP_UUID_ varchar(255)
);

create table BN_INCOMP_EVENTS (
  INCOMING_ID int8 not null,
  OUTGOING_ID int8
);

create table BN_INST_ACTUSERS (
  INSTANCE_DBID_ int8 not null,
  USER_ varchar(255),
  INDEX_ integer not null,
  primary key (INSTANCE_DBID_, INDEX_)
);

create table BN_MEMBERSHIP (
    DBID_ int8 not null,
    MEMBERSHIP_UUID_ varchar(255) unique,
    MEMBERSHIP_ROLE_ int8 not null,
    MEMBERSHIP_GROUP_ int8 not null,
    primary key (DBID_),
    unique (MEMBERSHIP_ROLE_, MEMBERSHIP_GROUP_)
);

create table BN_MEMBERSHIP_RULE (
  RULE_DBID_ int8 not null,
  MEMBERSHIP_UUID_ varchar(255)
);

create table BN_PROC_CAT (
  PROC_ID int8 not null,
  CAT_ varchar(255)
);

alter table BN_PROC_INST add PARENT_ACT_INST_UUID_ varchar(255);
alter table BN_PROC_INST add ARCHIVED bool;
update BN_PROC_INST set ARCHIVED=false;
alter table BN_PROC_INST alter column XP_READ_ drop not null;

create table BN_PROFILE_METADATA (
  DBID_ int8 not null,
  PROFILE_METADATA_UUID_ varchar(255) unique,
  PROFILE_METADATA_NAME_ varchar(255) unique,
  PROFILE_METADATA_LABEL_ varchar(255),
  primary key (DBID_)
);

alter table BN_ROLE alter ROLE_DESCRIPTION_ type text;

create table BN_ROLE_RULE (
  RULE_DBID_ int8 not null,
  ROLE_UUID_ varchar(255)
);

alter table BN_RULE add RULE_UUID_ varchar(255);
alter table BN_RULE add unique(RULE_UUID_);
update BN_RULE set RULE_TYPE_ = 'PROCESS_RULE' where RULE_TYPE_ = 'P_START';
update BN_RULE set RULE_TYPE_ = 'PROCESS_RULE' where RULE_TYPE_ = 'P_READ';

create table BN_RULETYPE_POLICY (
  DBID_ int8 not null,
  RULE_TYPE_VALUE_ varchar(255),
  POLICY_VALUE_ varchar(255),
  primary key (DBID_)
);

alter table BN_TRANS_DEF add FROM_BOUNDARY_EVT_ varchar(255);

alter table BN_USER add USER_TITLE_ varchar(255);
alter table BN_USER add USER_JOBTITLE_ varchar(255);
alter table BN_USER add USER_MANAGER_ varchar(255);
alter table BN_USER add USER_DELEGEE_ varchar(255);
alter table BN_USER rename column USER_EMAIL_ to USER_PRO_EMAIL_;
alter table BN_USER add USER_PRO_PHONE_ varchar(255);
alter table BN_USER add USER_PRO_MOBILE_ varchar(255);
alter table BN_USER add USER_PRO_FAX_ varchar(255);
alter table BN_USER add USER_PRO_BUILDING_ varchar(255);
alter table BN_USER add USER_PRO_ROOM_ varchar(255);
alter table BN_USER add USER_PRO_ADDRESS_ varchar(255);
alter table BN_USER add USER_PRO_ZIPCODE_ varchar(255);
alter table BN_USER add USER_PRO_CITY_ varchar(255);
alter table BN_USER add USER_PRO_STATE_ varchar(255);
alter table BN_USER add USER_PRO_COUNTRY_ varchar(255);
alter table BN_USER add USER_PRO_WEBSITE_ varchar(255);
alter table BN_USER add USER_PERSO_EMAIL_ varchar(255);
alter table BN_USER add USER_PERSO_PHONE_ varchar(255);
alter table BN_USER add USER_PERSO_MOBILE_ varchar(255);
alter table BN_USER add USER_PERSO_FAX_ varchar(255);
alter table BN_USER add USER_PERSO_BUILDING_ varchar(255);
alter table BN_USER add USER_PERSO_ROOM_ varchar(255);
alter table BN_USER add USER_PERSO_ADDRESS_ varchar(255);
alter table BN_USER add USER_PERSO_ZIPCODE_ varchar(255);
alter table BN_USER add USER_PERSO_CITY_ varchar(255);
alter table BN_USER add USER_PERSO_STATE_ varchar(255);
alter table BN_USER add USER_PERSO_COUNTRY_ varchar(255);
alter table BN_USER add USER_PERSO_WEBSITE_ varchar(255);

create table BN_USER_MEMBERSHIP (
    USER_DBID_ int8 not null,
    MEMBERSHIP_DBID_ int8 not null,
    primary key (USER_DBID_, MEMBERSHIP_DBID_)
);

create table BN_USER_PROFILE_METADATA (
    USER_DBID_ int8 not null,
    USER_METADATA_VALUE_ varchar(255),
    PROFILE_METADATA_DBID_ int8 not null,
    primary key (USER_DBID_, PROFILE_METADATA_DBID_)
);

drop table BN_USER_ROLE;

create table BN_USER_RULE (
  RULE_DBID_ int8 not null,
  USER_UUID_ varchar(255)
);

alter table BN_WEB_CASE alter column LAST_UPDATE drop not null;

alter table BN_WEB_TOKEN alter column TOKEN drop not null;
alter table BN_WEB_TOKEN alter column EXPIRATION_DATE drop not null;
alter table BN_WEB_TOKEN alter column IDENTITY_KEY drop not null;

drop table BN_WEB_USER;

alter table BN_EVENTS add constraint FKFC4B1C6CE4527CDB foreign key (EVT_DBID_) references BN_ACT_DEF;
alter table BN_EVENTS add constraint FKFC4B1C6C9F5E2C47 foreign key (TRANSITION_) references BN_TRANS_DEF;

create index IDX_GROUP_PARENT on BN_GROUP (PARENT_GROUP_);
create index IDX_GROUP_NAME on BN_GROUP (GROUP_NAME_);
create index IDX_GROUP_UUID on BN_GROUP (GROUP_UUID_);
alter table BN_GROUP add constraint FK8C5F00AC3308C74D foreign key (PARENT_GROUP_) references BN_GROUP;

alter table BN_GROUP_RULE add constraint FK81E3D2AF5D39E3A7 foreign key (RULE_DBID_) references BN_RULE;

create index IDX_INCOMING_INCOMP_ on BN_INCOMP_EVENTS (INCOMING_ID);
alter table BN_INCOMP_EVENTS add constraint FK_INCOMING_INCOMP foreign key (INCOMING_ID) references BN_IEI_;

create index IDX_INST_ACTUSERS on BN_INST_ACTUSERS (INSTANCE_DBID_);
alter table BN_INST_ACTUSERS add constraint FK_INST_ACTUSERS foreign key (INSTANCE_DBID_) references BN_PROC_INST;

create index IDX_MEMBERSHIP_UUID on BN_MEMBERSHIP (MEMBERSHIP_UUID_);
alter table BN_MEMBERSHIP add constraint FKE3CDD9A9734D1EA1 foreign key (MEMBERSHIP_GROUP_) references BN_GROUP;
alter table BN_MEMBERSHIP add constraint FKE3CDD9A928CF6E7D foreign key (MEMBERSHIP_ROLE_) references BN_ROLE;

alter table BN_MEMBERSHIP_RULE add constraint FKE5B60FD25D39E3A7 foreign key (RULE_DBID_) references BN_RULE;

create index IDX_PROC_CAT on BN_PROC_CAT (PROC_ID);
alter table BN_PROC_CAT add constraint FK_PROC_CAT foreign key (PROC_ID) references BN_PROC_DEF;

create index IDX_PROFILE_METADATA_UUID on BN_PROFILE_METADATA (PROFILE_METADATA_UUID_);
create index IDX_PROFILE_METADATA_NAME on BN_PROFILE_METADATA (PROFILE_METADATA_NAME_);

alter table BN_ROLE_RULE add constraint FKBC9DBCF25D39E3A7 foreign key (RULE_DBID_) references BN_RULE;

create index IDX_RULE_UUID on BN_RULE (RULE_UUID_);

alter table BN_USER_MEMBERSHIP add constraint FKD55F6ED7A76CD75A foreign key (MEMBERSHIP_DBID_) references BN_MEMBERSHIP;
alter table BN_USER_MEMBERSHIP add constraint FKD55F6ED7EA9FC244 foreign key (USER_DBID_) references BN_USER;

alter table BN_USER_PROFILE_METADATA add constraint FKA3C9A766FE1E43BD foreign key (PROFILE_METADATA_DBID_) references BN_PROFILE_METADATA;
alter table BN_USER_PROFILE_METADATA add constraint FKA3C9A766EA9FC244 foreign key (USER_DBID_) references BN_USER;

alter table BN_USER_RULE add constraint FKBCD31EBD5D39E3A7 foreign key (RULE_DBID_) references BN_RULE;
